unit tahtif;
{
  Esimerkki EI-suorakulmaisesta ikkunasta.
  Vesa Lappalainen kopioinut 5.6.1999
  Delphi Developer's Journal December 1998, vol 4, no. 12
  /by Kent Reidorph
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFormTahti = class(TForm)
    ButtonLopeta: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ButtonLopetaClick(Sender: TObject);
  private
    procedure WmNCHitTest(var Msg:TWMNCHitTest); message WM_NCHITTEST;
  public
  end;

var
  FormTahti: TFormTahti;

implementation

{$R *.DFM}
const
  { Taulukko thden pisteist }
  RgnTahti : array[1..10] of TPoint = (
    (x:203;y: 0),(x:157;y:168),(x:  3;y:168),
    (x:128;y:257),(x: 81;y:402),(x:203;y:334),
    (x:352;y:442),(x:278;y:257),(x:402;y:168),
    (x:249;y:168)
  );

procedure TFormTahti.FormCreate(Sender: TObject);
var Rgn:HRGN;
begin
  { Tehdn monitahkos pistejoukosta RgnTahti }
  Rgn := CreatePolygonRgn(RgnTahti,High(RgnTahti),ALTERNATE);
  { Asetetaan monitakohas ikkunan rajoiksi }
  SetWindowRgn(Handle,Rgn,True);
end;

procedure TFormTahti.ButtonLopetaClick(Sender: TObject);
begin
  Close;
end;

{ Tutkitaan otiskkopalkim viestit ja valehdellaan
  ett on tartuttu otsikkopalkkiin }
procedure TFormTahti.WmNCHitTest(var Msg:TWMNCHitTest);
begin
  DefaultHandler(Msg);
  if Msg.Result = HTCLIENT then
    Msg.Result := HTCAPTION;
end;

end.
